# zordfsdb

[![Build Status](https://drone.arns.lt/api/badges/zordsdavini/zordfsdb/status.svg)](https://drone.arns.lt/zordsdavini/zordfsdb)

Simple filesystem based key/value db. Provided as golang lib. Main idea is that user knows structure and gets value from known path. For operations that should search or do more should be used Nodes (golang structure).

## Configuration

Init root directory.

## Supported command

Commands can be split into value layer when you know the structure and node layer for deaper operations.

### value layer commands

* Get - to get value from path
* Save - update or create value. Depends on path. If path directs into not existing parent object - will return false
* Inc - increase abcex value
* Dec - decrease abcex value
* Now - save current datetime

### node layer commands

* GetNode - to get node. It can be object, list or value object. Returns false if not exist
* CreatNode - create list (director) to add many same objects (structure should be controlled by user) or single object. Parent Node should exist
* AddObject - add object to given list. Should assign abcex id

### helper commands

* Del - delete value, object or list by given path
* Keys - return possible keys for object or ids for list

## dictionary

* object - directory of key/value
* list - directory of objects named by abcex as key
* path - path to key or object or list

## DEV

Run tests: `$ go test`
